Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 128)
@@ -471,99 +565,108 @@
 
 #define ALLOC2_INTERFACE_END(x1, x2)                                    \
-  for (uint32_t it1=0; it1<x1; it1++)                                   \
-    delete [] interface [it1];                                          \
-  delete [] interface;
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        delete [] interface [it1];                                      \
+      delete [] interface;                                              \
+    } while (0)
 
 #define _ALLOC2_VAL_ACK_IN( sig, name, type, x1, x2)                    \
-  {                                                                     \
-    sig = new SC_IN (Tcontrol_t) ** [x1];                               \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_IN (Tcontrol_t) * [x2];                      \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = interface[it1][it2]->set_signal_valack_in (name, type); \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (Tcontrol_t) ** [x1];                             \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_IN (Tcontrol_t) * [x2];                    \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = interface[it1][it2]->set_signal_valack_in (name, type); \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 #define _ALLOC2_VAL_ACK_OUT( sig, name, type, x1, x2)                   \
-  {                                                                     \
-    sig = new SC_OUT (Tcontrol_t) ** [x1];                              \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_OUT (Tcontrol_t) * [x2];                     \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = interface[it1][it2]->set_signal_valack_out (name, type); \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT (Tcontrol_t) ** [x1];                            \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_OUT (Tcontrol_t) * [x2];                   \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = interface[it1][it2]->set_signal_valack_out (name, type); \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 #define _ALLOC2_VALACK_IN(    sig,type, x1, x2)                         \
-  {                                                                     \
-    sig = new SC_IN (Tcontrol_t) ** [x1];                               \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_IN (Tcontrol_t) * [x2];                      \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = interface[it1][it2]->set_signal_valack_in (type); \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (Tcontrol_t) ** [x1];                             \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_IN (Tcontrol_t) * [x2];                    \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = interface[it1][it2]->set_signal_valack_in (type); \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 #define _ALLOC2_VALACK_OUT(    sig,type, x1, x2)                        \
-  {                                                                     \
-    sig = new SC_OUT (Tcontrol_t) ** [x1];                              \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_OUT (Tcontrol_t) * [x2];                     \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            sig [it1][it2] = interface[it1][it2]->set_signal_valack_out (type); \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT (Tcontrol_t) ** [x1];                            \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_OUT (Tcontrol_t) * [x2];                   \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              sig [it1][it2] = interface[it1][it2]->set_signal_valack_out (type); \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 #define _ALLOC2_SIGNAL_IN( sig, name, type, size, x1, x2)               \
-  {                                                                     \
-    sig = new SC_IN (type) ** [x1];                                     \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_IN (type) * [x2];                            \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            if (size > 0)                                               \
-              {                                                         \
-                sig [it1][it2] = interface[it1][it2]->set_signal_in <type> (name, size); \
-              }                                                         \
-            else                                                        \
-              {                                                         \
-                PRINT_SIZE_NUL(_component,interface[it1][it2],name);    \
-              }                                                         \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (type) ** [x1];                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_IN (type) * [x2];                          \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              if (size > 0)                                             \
+                {                                                       \
+                  sig [it1][it2] = interface[it1][it2]->set_signal_in <type> (name, size); \
+                }                                                       \
+              else                                                      \
+                {                                                       \
+                  PRINT_SIZE_NUL(_component,interface[it1][it2],name);  \
+                }                                                       \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 #define _ALLOC2_SIGNAL_OUT( sig, name, type, size, x1, x2)              \
-  {                                                                     \
-    sig = new SC_OUT (type) ** [x1];                                    \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_OUT (type) * [x2];                           \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            if (size > 0)                                               \
-              {                                                         \
-                sig [it1][it2] = interface[it1][it2]->set_signal_out <type> (name, size); \
-              }                                                         \
-            else                                                        \
-              {                                                         \
-                PRINT_SIZE_NUL(_component,interface[it1][it2],name);    \
-              }                                                         \
-          }                                                             \
-      }                                                                 \
-  }
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT (type) ** [x1];                                  \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_OUT (type) * [x2];                         \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              if (size > 0)                                             \
+                {                                                       \
+                  sig [it1][it2] = interface[it1][it2]->set_signal_out <type> (name, size); \
+                }                                                       \
+              else                                                      \
+                {                                                       \
+                  PRINT_SIZE_NUL(_component,interface[it1][it2],name);  \
+                }                                                       \
+            }                                                           \
+        }                                                               \
+    } while (0)
 
 #define ALLOC2_VAL_ACK_IN( sig, name, type      ) _ALLOC2_VAL_ACK_IN( sig, name, type      , iterator_1, iterator_2) 
@@ -575,103 +678,116 @@
 
 #define DELETE2_SIGNAL(sig, x1,x2, size)                                \
-  {                                                                     \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              if (size > 0)                                             \
+                {                                                       \
+                  delete sig[it1][it2];                                 \
+                }                                                       \
+            }                                                           \
+          delete [] sig[it1];                                           \
+        }                                                               \
+      delete [] sig;                                                    \
+    } while (0)
+
+#define ALLOC2_FOREIGN_SIGNAL_IN( sig, interface, name, type, size, x1, x2) \
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_IN (type) ** [x1];                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_IN (type) * [x2];                          \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            if (size > 0)                                               \
+              {                                                         \
+                std::string str = (toString("in")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(it2)+"_"+toString(name)); \
+                sig [it1][it2] = new SC_IN    (type) (str.c_str());     \
+              }                                                         \
+        }                                                               \
+    } while (0)
+
+#define ALLOC2_FOREIGN_SIGNAL_OUT( sig, interface, name, type, size, x1, x2) \
+  do                                                                    \
+    {                                                                   \
+      sig = new SC_OUT (type) ** [x1];                                  \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          sig [it1] = new SC_OUT (type) * [x2];                         \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            if (size > 0)                                               \
+              {                                                         \
+                std::string str = (toString("out")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(it2)+"_"+toString(name)); \
+                sig [it1][it2] = new SC_IN    (type) (str.c_str());     \
+              }                                                         \
+        }                                                               \
+    } while (0)
+
+#define DELETE2_FOREIGN_SIGNAL( sig, size,x1,x2)            \
+  do                                                        \
+    {                                                       \
+      DELETE2_SIGNAL(sig,x1,x2,size);                       \
+    } while (0)
+
+#define ALLOC2_SC_SIGNAL( sig, name, type, x1, x2)                      \
+  do                                                                    \
+    {                                                                   \
+      sig = new sc_signal<type> ** [x1];                                \
       {                                                                 \
+        std::string separator="_";                                      \
+        std::string str;                                                \
+        for (uint32_t it1=0; it1<x1; it1++)                             \
+          {                                                             \
+            sig [it1] = new sc_signal<type> * [x2];                     \
+            for (uint32_t it2=0; it2<x2; it2++)                         \
+              {                                                         \
+                str = name+separator+toString(it1)+separator+toString(it2); \
+                sig [it1][it2] = new sc_signal<type> (str.c_str());     \
+                PRINT_SIGNAL_ADDRESS(str.c_str(),sig[it1][it2]);        \
+              }                                                         \
+          }                                                             \
+      }                                                                 \
+    } while (0)
+
+#define INSTANCE2_SC_SIGNAL(component, sig, x1, x2)                     \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
         for (uint32_t it2=0; it2<x2; it2++)                             \
           {                                                             \
-            if (size > 0)                                               \
-              {                                                         \
-                delete sig[it1][it2];                                   \
-              }                                                         \
+            TEST_SIGNAL(component->sig  [it1][it2]->name(),component->sig  [it1][it2]); \
+            TEST_SIGNAL(sig             [it1][it2]->name(),sig             [it1][it2]); \
+            (*(component->sig[it1][it2])) (*(sig[it1][it2]));           \
           }                                                             \
-        delete [] sig[it1];                                             \
-      }                                                                 \
-    delete [] sig;                                                      \
-  }
-
-
-#define ALLOC2_FOREIGN_SIGNAL_IN( sig, interface, name, type, size, x1, x2) \
-  {                                                                     \
-    sig = new SC_IN (type) ** [x1];                                     \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_IN (type) * [x2];                            \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          if (size > 0)                                                 \
-            {                                                           \
-              std::string str = (toString("in")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(it2)+"_"+toString(name)); \
-              sig [it1][it2] = new SC_IN    (type) (str.c_str()); \
-            }                                                           \
-      }                                                                 \
-  }
-
-#define ALLOC2_FOREIGN_SIGNAL_OUT( sig, interface, name, type, size, x1, x2) \
-  {                                                                     \
-    sig = new SC_OUT (type) ** [x1];                                    \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new SC_OUT (type) * [x2];                           \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          if (size > 0)                                                 \
-            {                                                           \
-              std::string str = (toString("out")+"_"+((interface!="")?(toString(interface)+"_"):toString(""))+toString(it1)+"_"+toString(it2)+"_"+toString(name)); \
-              sig [it1][it2] = new SC_IN    (type) (str.c_str());       \
-            }                                                           \
-      }                                                                 \
-  }
-
-#define DELETE2_FOREIGN_SIGNAL( sig, size,x1,x2)            \
-  {                                                         \
-    DELETE2_SIGNAL(sig,x1,x2,size);                         \
-  }
-
-#define ALLOC2_SC_SIGNAL( sig, name, type, x1, x2)                      \
-  sig = new sc_signal<type> ** [x1];                                    \
-  {                                                                     \
-    std::string separator="_";                                          \
-    std::string str;                                                    \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        sig [it1] = new sc_signal<type> * [x2];                         \
+    } while (0)
+
+#define _INSTANCE2_SC_SIGNAL(component, sig1, sig2, x1, x2)             \
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
         for (uint32_t it2=0; it2<x2; it2++)                             \
           {                                                             \
-            str = name+separator+toString(it1)+separator+toString(it2); \
-            sig [it1][it2] = new sc_signal<type> (str.c_str());         \
-            PRINT_SIGNAL_ADDRESS(str.c_str(),sig[it1][it2]);            \
+            TEST_SIGNAL(component->sig1 [it1][it2]->name(),component->sig1 [it1][it2]); \
+            TEST_SIGNAL(sig2            [it1][it2]->name(),sig2            [it1][it2]); \
+            (*(component->sig1[it1][it2])) (*(sig2[it1][it2]));         \
           }                                                             \
-      }                                                                 \
-  }
-
-#define INSTANCE2_SC_SIGNAL(component, sig, x1, x2)                     \
-  for (uint32_t it1=0; it1<x1; it1++)                                   \
-    for (uint32_t it2=0; it2<x2; it2++)                                 \
-      {                                                                 \
-        TEST_SIGNAL(component->sig  [it1][it2]->name(),component->sig  [it1][it2]); \
-        TEST_SIGNAL(sig             [it1][it2]->name(),sig             [it1][it2]); \
-        (*(component->sig[it1][it2])) (*(sig[it1][it2]));               \
-      }
-
-#define _INSTANCE2_SC_SIGNAL(component, sig1, sig2, x1, x2)             \
-  for (uint32_t it1=0; it1<x1; it1++)                                   \
-    for (uint32_t it2=0; it2<x2; it2++)                                 \
-      {                                                                 \
-        TEST_SIGNAL(component->sig1 [it1][it2]->name(),component->sig1 [it1][it2]); \
-        TEST_SIGNAL(sig2            [it1][it2]->name(),sig2            [it1][it2]); \
-        (*(component->sig1[it1][it2])) (*(sig2[it1][it2]));             \
-      }
+    } while (0)
 
 #define DELETE2_SC_SIGNAL(sig,x1,x2)                                    \
-  {                                                                     \
-    for (uint32_t it1=0; it1<x1; it1++)                                 \
-      {                                                                 \
-        for (uint32_t it2=0; it2<x2; it2++)                             \
-          {                                                             \
-            PRINT_SIGNAL_ADDRESS("",sig[it1][it2]);                     \
-            delete sig[it1][it2];                                       \
-          }                                                             \
-        delete [] sig[it1];                                             \
-      }                                                                 \
-    delete [] sig;                                                      \
-  }
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            {                                                           \
+              PRINT_SIGNAL_ADDRESS("",sig[it1][it2]);                   \
+              delete sig[it1][it2];                                     \
+            }                                                           \
+          delete [] sig[it1];                                           \
+        }                                                               \
+      delete [] sig;                                                    \
+    } while (0)
 
 // ----------------------------------------------------------------------
@@ -734,11 +850,14 @@
 
 #define ALLOC3_INTERFACE_END(x1, x2, x3)                         \
-  for (uint32_t it1=0; it1<x1; it1++)                                   \
-    {                                                                   \
-      for (uint32_t it2=0; it2<x2; it2++)                               \
-        delete [] interface [it1][it2];                                 \
-      delete [] interface [it1];                                        \
-    }                                                                   \
-  delete [] interface;
+  do                                                                    \
+    {                                                                   \
+      for (uint32_t it1=0; it1<x1; it1++)                               \
+        {                                                               \
+          for (uint32_t it2=0; it2<x2; it2++)                           \
+            delete [] interface [it1][it2];                             \
+          delete [] interface [it1];                                    \
+        }                                                               \
+      delete [] interface;                                              \
+    } while (0)
 
 // #define _ALLOC3_VAL_ACK_IN( sig, name, type, x1, x2, x3)
